{*******************************************************}
{                                                       }
{       RichViewActions                                 }
{       DB Demo project.                                }
{       You can use it as a basis for your              }
{       applications.                                   }
{                                                       }
{       Copyright (c) Sergey Tkachenko                  }
{       svt@trichview.com                               }
{       https://www.trichview.com                       }
{                                                       }
{*******************************************************}

unit Unit3Unicode;

interface

uses
  // Delphi units
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  ActnList, StdActns, ImgList, ToolWin,
  Menus, ShellApi, Printers, ExtCtrls, Mask, DBCtrls, Actions,
  // FireDAC units
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error,
  FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool,
  FireDAC.Stan.Async, FireDAC.Phys, FireDAC.VCLUI.Wait, FireDAC.Stan.Param,
  FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt,
  FireDAC.Phys.IBBase, FireDAC.Phys.IB, Data.DB, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client,
  // TRichView units
  RVUni, RVMisc, RVScroll, RichView, RVEdit,
  RVStyle, CRVFData, RVTable, RVItem, CRVData, RVFuncs, RVNote,
  RVGifAnimate2007, RVTypes,
  // RichViewActions units
  RichViewActions, RVFontCombos, RVRulerBase, RVRuler,
  RVALocalize, RVALocRuler, RVStyleFuncs,
  // ScaleRichView units
  SRVPageScroll, SclRView, SclRVRuler, SRVToolWindow,
  SRVToolBar, SRVSkinManager, SRVTabSet, SRVActions, SRVALocalize, SRVIMouse,
  DBSRVE,
  // Demo units
  SRVImages1, SRVImages2, SRVSearch;

type
  TForm3 = class(TForm)
    MainMenu1: TMainMenu;
    mitFile: TMenuItem;
    mitEdit: TMenuItem;
    N1: TMenuItem;
    mitExit: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    n2: TMenuItem;
    mitFont: TMenuItem;
    Bold1: TMenuItem;
    Italic1: TMenuItem;
    Underline1: TMenuItem;
    N3: TMenuItem;
    mitPara: TMenuItem;
    Leftjustify1: TMenuItem;
    N4: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    Strikeout1: TMenuItem;
    mitTable: TMenuItem;
    InsertTable1: TMenuItem;
    N5: TMenuItem;
    SelectAll1: TMenuItem;
    AlignLeft1: TMenuItem;
    AlignCenter1: TMenuItem;
    AlignRight1: TMenuItem;
    N6: TMenuItem;
    DecreaseIndent1: TMenuItem;
    IncreaseIndent1: TMenuItem;
    N7: TMenuItem;
    Justify1: TMenuItem;
    InsertRowAbove1: TMenuItem;
    InsertRowBelow1: TMenuItem;
    N8: TMenuItem;
    InsertColumnLeft1: TMenuItem;
    InsertColumnRight1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    DeleteRows1: TMenuItem;
    rvActionTableDeleteCols11: TMenuItem;
    N11: TMenuItem;
    MergeCells1: TMenuItem;
    SplitCells1: TMenuItem;
    N12: TMenuItem;
    mitTableSelect: TMenuItem;
    SelectTable1: TMenuItem;
    SelectColumns1: TMenuItem;
    SelectRows1: TMenuItem;
    SelectCell1: TMenuItem;
    mitFontStyle: TMenuItem;
    mitFontSize: TMenuItem;
    ShrinkFont1: TMenuItem;
    GrowFont1: TMenuItem;
    N13: TMenuItem;
    ShrinkFontByOnePoint1: TMenuItem;
    GrowFontByOnePoint1: TMenuItem;
    N14: TMenuItem;
    AllCapitals1: TMenuItem;
    Overline1: TMenuItem;
    N15: TMenuItem;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    Replace1: TMenuItem;
    N16: TMenuItem;
    extColor1: TMenuItem;
    extBackgroundColor1: TMenuItem;
    N17: TMenuItem;
    ParagraphBackgroundColor1: TMenuItem;
    mitFormat: TMenuItem;
    BackgroundColor1: TMenuItem;
    DeleteTable1: TMenuItem;
    N18: TMenuItem;
    rvActionParagraph11: TMenuItem;
    RVAControlPanel1: TRVAControlPanel;
    Font1: TMenuItem;
    FillColor1: TMenuItem;
    Export1: TMenuItem;
    mitInsert: TMenuItem;
    File1: TMenuItem;
    Picture1: TMenuItem;
    PasteSpecial1: TMenuItem;
    N19: TMenuItem;
    SingleLineSpacing1: TMenuItem;
    N15LineSpacing1: TMenuItem;
    DoubleLineSpacing1: TMenuItem;
    N20: TMenuItem;
    InsertPageBreak1: TMenuItem;
    RemovePageBreak1: TMenuItem;
    N21: TMenuItem;
    mitTableAlignCellContents: TMenuItem;
    AlignCellToTheTop1: TMenuItem;
    AlignCellToTheMiddle1: TMenuItem;
    AlignCellToTheBottom1: TMenuItem;
    DefaultCellVerticalAlignment1: TMenuItem;
    ParagraphBorders1: TMenuItem;
    N22: TMenuItem;
    Properties1: TMenuItem;
    HorizontalLine1: TMenuItem;
    HypertextLink1: TMenuItem;
    N23: TMenuItem;
    ableProperties1: TMenuItem;
    N24: TMenuItem;
    ShowGridLines1: TMenuItem;
    N25: TMenuItem;
    BulletsandNumbering1: TMenuItem;
    InsertSymbol1: TMenuItem;
    mitTableCellBorders: TMenuItem;
    LeftBorder1: TMenuItem;
    rvActionTableCellTopBorder11: TMenuItem;
    rvActionTableCellRightBorder11: TMenuItem;
    rvActionTableCellBottomBorder11: TMenuItem;
    rvActionTableCellAllBorders11: TMenuItem;
    rvActionTableCellNoBorders11: TMenuItem;
    Bullets1: TMenuItem;
    Numbering1: TMenuItem;
    RVAPopupMenu1: TRVAPopupMenu;
    Background1: TMenuItem;
    ColorDialog1: TColorDialog;
    N26: TMenuItem;
    CharacterCase1: TMenuItem;
    pmFakeDropDown: TPopupMenu;
    Panel1: TPanel;
    panSRV: TPanel;
    SclRVRuler1: TSclRVRuler;
    Panel4: TPanel;
    RVRulerItemSelector1: TRVRulerItemSelector;
    fd: TFindDialog;
    rd: TReplaceDialog;
    HintTableMenu: TPopupMenu;
    SampleHintTablemenu1: TMenuItem;
    mitPageSetup: TMenuItem;
    mitPrint: TMenuItem;
    N27: TMenuItem;
    rvActionSubscript11: TMenuItem;
    rvActionSuperscript11: TMenuItem;
    SRVPageScroll1: TSRVPageScroll;
    stat1: TStatusBar;
    btnLanguage: TButton;
    SclRVRuler2: TSclRVRuler;
    Splitter1: TSplitter;
    DBSRichViewEdit1: TDBSRichViewEdit;
    ilDocTypes: TImageList;
    SRVSkinManager1: TSRVSkinManager;
    N28: TMenuItem;
    N29: TMenuItem;
    RemoveHyperlinks1: TMenuItem;
    ObjectPosition1: TMenuItem;
    PasteasText1: TMenuItem;
    N30: TMenuItem;
    mitTextFlow: TMenuItem;
    ClearTextFlowatLeftSide1: TMenuItem;
    ClearTextFlowatRightSide1: TMenuItem;
    ClearTextFlowatBothSides1: TMenuItem;
    NormalTextFlow1: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    btnQuickPrint: TToolButton;
    ToolButton4: TToolButton;
    ToolButton32: TToolButton;
    ToolButton33: TToolButton;
    ToolButton34: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ToolButton5: TToolButton;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton10: TToolButton;
    ToolButton46: TToolButton;
    ToolButton12: TToolButton;
    ToolButton47: TToolButton;
    ToolButton62: TToolButton;
    ToolButton63: TToolButton;
    ToolBar2: TToolBar;
    ToolButton41: TToolButton;
    ToolButton42: TToolButton;
    ToolButton43: TToolButton;
    ToolButton44: TToolButton;
    ToolButton29: TToolButton;
    ToolButton64: TToolButton;
    ToolButton13: TToolButton;
    ToolButton22: TToolButton;
    ToolButton6: TToolButton;
    ToolButton30: TToolButton;
    ToolButton31: TToolButton;
    ToolButton35: TToolButton;
    ToolButton36: TToolButton;
    ToolButton38: TToolButton;
    ToolButton37: TToolButton;
    ToolButton49: TToolButton;
    ToolButton50: TToolButton;
    ToolButton51: TToolButton;
    ToolButton8: TToolButton;
    ToolButton7: TToolButton;
    ToolButton57: TToolButton;
    ToolButton61: TToolButton;
    ToolButton60: TToolButton;
    ToolButton53: TToolButton;
    ToolButton54: TToolButton;
    ToolButton40: TToolButton;
    ToolButton39: TToolButton;
    ToolBar3: TToolBar;
    ToolButton9: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton27: TToolButton;
    ToolButton23: TToolButton;
    ToolButton24: TToolButton;
    ToolButton45: TToolButton;
    ToolButton28: TToolButton;
    ToolButton25: TToolButton;
    ToolButton26: TToolButton;
    ToolBar4: TToolBar;
    ToolButton48: TToolButton;
    ToolButton52: TToolButton;
    ToolButton55: TToolButton;
    ToolButton56: TToolButton;
    ToolButton58: TToolButton;
    ToolButton59: TToolButton;
    ToolBar5: TToolBar;
    cmbFont: TRVFontComboBox;
    cmbFontSize: TRVFontSizeComboBox;
    ToolButton66: TToolButton;
    ToolButton65: TToolButton;
    btnPageFormat: TToolButton;
    cmbZoom: TComboBox;
    cmbUnits: TComboBox;
    ToolBar6: TToolBar;
    ToolButton71: TToolButton;
    ToolButton72: TToolButton;
    ToolButton75: TToolButton;
    ToolButton76: TToolButton;
    ToolButton77: TToolButton;
    ToolButton78: TToolButton;
    pmPageFormat: TPopupMenu;
    A41: TMenuItem;
    A42: TMenuItem;
    A61: TMenuItem;
    Letter1: TMenuItem;
    Legal1: TMenuItem;
    N1000x1000mm1: TMenuItem;
    N31: TMenuItem;
    PageSetup1: TMenuItem;
    N32: TMenuItem;
    Footnote1: TMenuItem;
    Endnote1: TMenuItem;
    EditNote1: TMenuItem;
    ReturntoNote1: TMenuItem;
    srvtwSearch: TSRVToolWindow;
    ToolButton67: TToolButton;
    ToolButton68: TToolButton;
    Hide1: TMenuItem;
    mitTableCellRotation: TMenuItem;
    NoCellRotation1: TMenuItem;
    RotateCellby90Degrees1: TMenuItem;
    RotateCellby180Degrees1: TMenuItem;
    RotateCellby270Degrees1: TMenuItem;
    ConverttoText1: TMenuItem;
    SplitTable1: TMenuItem;
    Sort1: TMenuItem;
    ToolButton69: TToolButton;
    ToolButton70: TToolButton;
    ToolButton73: TToolButton;
    pmZoom: TPopupMenu;
    N251: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N1501: TMenuItem;
    N2001: TMenuItem;
    N5001: TMenuItem;
    N33: TMenuItem;
    srvActionZoomFullPage11: TMenuItem;
    srvActionZoomPageWidth11: TMenuItem;
    ProgressBar1: TProgressBar;
    ToolBar7: TToolBar;
    cmbStyles: TRVStyleTemplateComboBox;
    ToolButton74: TToolButton;
    N34: TMenuItem;
    Styles1: TMenuItem;
    AddStyle1: TMenuItem;
    ClearTextFormat1: TMenuItem;
    ClearFormat1: TMenuItem;
    InspectStyles1: TMenuItem;
    ToolButton79: TToolButton;
    Sidenote1: TMenuItem;
    Sidenote2: TMenuItem;
    Number1: TMenuItem;
    InsertCaption1: TMenuItem;
    InsertCaption2: TMenuItem;
    DeleteTable2: TMenuItem;
    PageNumber1: TMenuItem;
    ActionList1: TActionList;
    rvActionExport1: TrvActionExport;
    rvActionCut1: TrvActionCut;
    rvActionCopy1: TrvActionCopy;
    rvActionPaste1: TrvActionPaste;
    rvActionParagraph1: TrvActionParagraph;
    rvActionIndentInc1: TrvActionIndentInc;
    rvActionIndentDec1: TrvActionIndentDec;
    rvActionPasteAsText1: TrvActionPasteAsText;
    rvActionPasteSpecial1: TrvActionPasteSpecial;
    rvActionSelectAll1: TrvActionSelectAll;
    rvActionUndo1: TrvActionUndo;
    rvActionRedo1: TrvActionRedo;
    rvActionFonts1: TrvActionFonts;
    rvActionFontEx1: TrvActionFontEx;
    rvActionFontBold1: TrvActionFontBold;
    rvActionFontItalic1: TrvActionFontItalic;
    rvActionFontUnderline1: TrvActionFontUnderline;
    rvActionFontStrikeout1: TrvActionFontStrikeout;
    rvActionFontGrow1: TrvActionFontGrow;
    rvActionFontShrink1: TrvActionFontShrink;
    rvActionFontGrowOnePoint1: TrvActionFontGrowOnePoint;
    rvActionFontShrinkOnePoint1: TrvActionFontShrinkOnePoint;
    rvActionWordWrap1: TrvActionWordWrap;
    rvActionAlignLeft1: TrvActionAlignLeft;
    rvActionAlignRight1: TrvActionAlignRight;
    rvActionAlignCenter: TrvActionAlignCenter;
    rvActionAlignJustify1: TrvActionAlignJustify;
    rvActionInsertTable1: TrvActionInsertTable;
    rvActionTableInsertRowsAbove1: TrvActionTableInsertRowsAbove;
    rvActionTableInsertRowsBelow1: TrvActionTableInsertRowsBelow;
    rvActionTableInsertColLeft1: TrvActionTableInsertColLeft;
    rvActionTableInsertColRight1: TrvActionTableInsertColRight;
    rvActionTableDeleteRows1: TrvActionTableDeleteRows;
    rvActionTableDeleteCols1: TrvActionTableDeleteCols;
    rvActionTableDeleteTable1: TrvActionTableDeleteTable;
    rvActionTableMergeCells1: TrvActionTableMergeCells;
    rvActionTableSplitCells1: TrvActionTableSplitCells;
    rvActionTableSelectTable1: TrvActionTableSelectTable;
    rvActionTableSelectRows1: TrvActionTableSelectRows;
    rvActionTableSelectCols1: TrvActionTableSelectCols;
    rvActionTableSelectCell1: TrvActionTableSelectCell;
    rvActionFontAllCaps1: TrvActionFontAllCaps;
    rvActionFontOverline1: TrvActionFontOverline;
    rvActionFind1: TrvActionFind;
    rvActionFindNext1: TrvActionFindNext;
    rvActionReplace1: TrvActionReplace;
    rvActionFontColor1: TrvActionFontColor;
    rvActionFontBackColor1: TrvActionFontBackColor;
    rvActionParaColor1: TrvActionParaColor;
    rvActionColor1: TrvActionColor;
    rvActionFillColor1: TrvActionFillColor;
    rvActionInsertFile1: TrvActionInsertFile;
    rvActionInsertPicture1: TrvActionInsertPicture;
    rvActionLineSpacing1001: TrvActionLineSpacing100;
    rvActionLineSpacing1501: TrvActionLineSpacing150;
    rvActionLineSpacing2001: TrvActionLineSpacing200;
    rvActionInsertPageBreak1: TrvActionInsertPageBreak;
    rvActionRemovePageBreak1: TrvActionRemovePageBreak;
    rvActionTableCellVAlignTop1: TrvActionTableCellVAlignTop;
    rvActionTableCellVAlignMiddle1: TrvActionTableCellVAlignMiddle;
    rvActionTableCellVAlignBottom1: TrvActionTableCellVAlignBottom;
    rvActionTableCellVAlignDefault1: TrvActionTableCellVAlignDefault;
    rvActionParaBorder1: TrvActionParaBorder;
    rvActionItemProperties1: TrvActionItemProperties;
    rvActionInsertHLine1: TrvActionInsertHLine;
    rvActionInsertHyperlink1: TrvActionInsertHyperlink;
    rvActionTableProperties1: TrvActionTableProperties;
    rvActionTableGrid1: TrvActionTableGrid;
    rvActionParaList1: TrvActionParaList;
    rvActionInsertSymbol1: TrvActionInsertSymbol;
    rvActionTableCellLeftBorder1: TrvActionTableCellLeftBorder;
    rvActionTableCellRightBorder1: TrvActionTableCellRightBorder;
    rvActionTableCellTopBorder1: TrvActionTableCellTopBorder;
    rvActionTableCellBottomBorder1: TrvActionTableCellBottomBorder;
    rvActionTableCellAllBorders1: TrvActionTableCellAllBorders;
    rvActionTableCellNoBorders1: TrvActionTableCellNoBorders;
    rvActionParaBullets1: TrvActionParaBullets;
    rvActionParaNumbering1: TrvActionParaNumbering;
    rvActionBackground1: TrvActionBackground;
    rvActionTextRTL1: TrvActionTextRTL;
    rvActionTextLTR1: TrvActionTextLTR;
    rvActionParaRTL1: TrvActionParaRTL;
    rvActionParaLTR1: TrvActionParaLTR;
    rvActionCharCase1: TrvActionCharCase;
    rvActionShowSpecialCharacters1: TrvActionShowSpecialCharacters;
    rvActionSubscript1: TrvActionSubscript;
    rvActionSuperscript1: TrvActionSuperscript;
    rvActionClearLeft1: TrvActionClearLeft;
    rvActionClearRight1: TrvActionClearRight;
    rvActionClearBoth1: TrvActionClearBoth;
    rvActionClearNone1: TrvActionClearNone;
    rvActionVAlign1: TrvActionVAlign;
    rvActionRemoveHyperlinks1: TrvActionRemoveHyperlinks;
    srvActionQuickPrint1: TsrvActionQuickPrint;
    srvActionPrint1: TsrvActionPrint;
    srvActionPageSetup1: TsrvActionPageSetup;
    srvActionLayoutPrint1: TsrvActionLayoutPrint;
    srvActionLayoutWeb1: TsrvActionLayoutWeb;
    srvActionLayoutDraft1: TsrvActionLayoutDraft;
    srvActionZoomPageWidth1: TsrvActionZoomPageWidth;
    srvActionZoomFullPage1: TsrvActionZoomFullPage;
    srvActionOrientationPortrait1: TsrvActionOrientationPortrait;
    srvActionOrientationLandscape1: TsrvActionOrientationLandscape;
    srvActionEditHeader1: TsrvActionEditHeader;
    srvActionEditFooter1: TsrvActionEditFooter;
    srvActionEditMain1: TsrvActionEditMain;
    srvActionPageFormatA4: TsrvActionPageFormat;
    srvActionPageFormatA5: TsrvActionPageFormat;
    srvActionPageFormatA6: TsrvActionPageFormat;
    srvActionPageFormatLetter: TsrvActionPageFormat;
    srvActionPageFormatLegal: TsrvActionPageFormat;
    srvActionPageFormatTest: TsrvActionPageFormat;
    srvActionPreview1: TsrvActionPreview;
    srvActionThumbnails1: TsrvActionThumbnails;
    srvActionInsertFootnote1: TsrvActionInsertFootnote;
    srvActionInsertEndnote1: TsrvActionInsertEndnote;
    srvActionEditNote1: TsrvActionEditNote;
    srvActionReturnToNote1: TsrvActionReturnToNote;
    rvActionHide1: TrvActionHide;
    rvActionTableCellRotationNone1: TrvActionTableCellRotationNone;
    rvActionTableCellRotation901: TrvActionTableCellRotation90;
    rvActionTableCellRotation1801: TrvActionTableCellRotation180;
    rvActionTableCellRotation2701: TrvActionTableCellRotation270;
    rvActionTableSplit1: TrvActionTableSplit;
    rvActionTableToText1: TrvActionTableToText;
    rvActionTableSort1: TrvActionTableSort;
    srvActionZoom25: TsrvActionZoom;
    srvActionZoom50: TsrvActionZoom;
    srvActionZoom75: TsrvActionZoom;
    srvActionZoom100: TsrvActionZoom;
    srvActionZoom150: TsrvActionZoom;
    srvActionZoom200: TsrvActionZoom;
    srvActionZoom500: TsrvActionZoom;
    rvActionStyleTemplates1: TrvActionStyleTemplates;
    rvActionAddStyleTemplate1: TrvActionAddStyleTemplate;
    rvActionClearFormat1: TrvActionClearFormat;
    rvActionClearTextFormat1: TrvActionClearTextFormat;
    rvActionStyleInspector1: TrvActionStyleInspector;
    srvActionInsertSidenote1: TsrvActionInsertSidenote;
    srvActionInsertTextBox1: TsrvActionInsertTextBox;
    rvActionInsertNumber1: TrvActionInsertNumber;
    rvActionInsertCaption1: TrvActionInsertCaption;
    rvActionInsertPageNumber1: TrvActionInsertPageNumber;
    mitTools: TMenuItem;
    mitImages1: TMenuItem;
    mitImages2: TMenuItem;
    N35: TMenuItem;
    mitLanguage: TMenuItem;
    mitOptions: TMenuItem;
    rvActionAlignDistribute1: TrvActionAlignDistribute;
    ToolButton80: TToolButton;
    rvActionAlignDistribute11: TMenuItem;
    rvActionInsertPageCount1: TrvActionInsertPageCount;
    PageCount1: TMenuItem;
    rvActionTableCellVerticalFonts1: TrvActionTableCellVerticalFonts;
    rvActionTableCellReverseLineOrder1: TrvActionTableCellReverseLineOrder;
    srvActionLineNumbers1: TsrvActionLineNumbers;
    LineNumbers1: TMenuItem;
    N36: TMenuItem;
    UseVerticalFonts1: TMenuItem;
    ReverseLineOrder1: TMenuItem;
    rvActionBookmarks1: TrvActionBookmarks;
    Bookmark1: TMenuItem;
    DBNavigator1: TDBNavigator;
    FDConnection1: TFDConnection;
    FDTable1: TFDTable;
    DataSource1: TDataSource;
    FDPhysIBDriverLink1: TFDPhysIBDriverLink;
    panTitle: TPanel;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    rvActionNew1: TrvActionNew;
    procedure FormCreate(Sender: TObject);
    procedure mitExitClick(Sender: TObject);
    procedure RichViewEdit1_Jump(Sender: TObject; id: Integer);
    procedure RichViewEdit1_ReadHyperlink(Sender: TCustomRichView;
      const Target, Extras: TRVUnicodeString; DocFormat: TRVLoadFormat;
      var StyleNo: Integer; var ItemTag: TRVTag;
      var ItemName: TRVUnicodeString);
    procedure btnLanguageClick(Sender: TObject);
    procedure RVAControlPanel1MarginsChanged(Sender: TrvAction;
      Edit: TCustomRichViewEdit);
    procedure RVAControlPanel1Download(Sender: TrvAction;
      const Source: TRVUnicodeString);
    procedure RichViewEdit1_KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pmFakeDropDownPopup(Sender: TObject);
    procedure RichViewEdit1_KeyPress(Sender: TObject; var Key: Char);
    procedure DBSRichViewEdit1CurrentPageChange(Sender: TObject);
    procedure DBSRichViewEdit1HMenuClickButton(Sender: TObject;
      ToolButton: TSRVToolButton);
    procedure DBSRichViewEdit1PageScrolled(Sender: TObject);
    procedure DBSRichViewEdit1CaretMove(Sender: TObject);
    procedure SclRVRuler1MarginDblClick(Sender: TObject; Margin: TMarginType);
    procedure RVAControlPanel1BackgroundChange(Sender: TrvAction;
      Edit: TCustomRichViewEdit);
    procedure DBSRichViewEdit1TableIconClick(Sender: TSRichViewEdit;
      Button: TMouseButton; Shift: TShiftState; X, Y, PageNo: Integer);
    procedure RVAControlPanel1ViewChanged(Sender: TrvCustomAction;
      Edit: TCustomRichViewEdit);
    procedure cmbZoomChange(Sender: TObject);
    procedure DBSRichViewEdit1ZoomChanged(Sender: TObject);
    procedure DBSRichViewEdit1ChangeActiveEditor(Sender: TSRichViewEdit;
      ActiveEditor: TRichViewEdit);
    procedure cmbUnitsClick(Sender: TObject);
    procedure DBSRichViewEdit1SmartPopupClick(Sender: TCustomRichView;
      Button: TCustomControl);
    procedure DBSRichViewEdit1Printing(Sender: TSRichViewEdit;
      PageCompleted: Integer; Step: TRVPrintingStep);
    procedure DBSRichViewEdit1Progress(Sender: TCustomRichView;
      Operation: TRVLongOperation; Stage: TRVProgressStage; PercentDone: Byte);
    procedure srvActionThumbnails1Executed(Sender: TObject);
    procedure mitImages1Click(Sender: TObject);
    procedure mitImages2Click(Sender: TObject);
    procedure mitOptionsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure FDTable1AfterScroll(DataSet: TDataSet);
    procedure DBSRichViewEdit1NewDocument(Sender: TObject);
  private
    { Private declarations }
    SearchHelper: TSRVSearchHelper;
    UpdatingCombos:   Boolean;
    SmartPopupAction: TrvCustomAction;
    procedure ColorPickerShow(Sender: TObject);
    procedure ColorPickerHide(Sender: TObject);
    procedure ApplicationHint(Sender: TObject);
    procedure Localize;
    procedure UpdateSmartPopup;
    procedure ChangeImages(ilNormal, ilDisabled, ilMenuH, ilMenuV,
      ilSearchToolWin: TCustomImageList; IconStyle: TSRVIconStyle;
      SearchToolWinColor, SearchToolWinFontColor, SearchToolSelColor,
      SearchToolDownColor: TColor);
    procedure DetectURL;
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

uses Math, ActionTestOptionsFrm;
{$R *.dfm}

{------------------------------------------------------------------------------}

procedure TForm3.FormCreate(Sender: TObject);
begin
  SearchHelper := TSRVSearchHelper.Create(DBSRichViewEdit1, fd, srvtwSearch);

  // Code for making color-picking buttons stay pressed while a
  // color-picker window is visible.
  rvActionColor1.OnShowColorPicker := ColorPickerShow;
  rvActionColor1.OnHideColorPicker := ColorPickerHide;
  rvActionParaColor1.OnShowColorPicker := ColorPickerShow;
  rvActionParaColor1.OnHideColorPicker := ColorPickerHide;
  rvActionFontColor1.OnShowColorPicker := ColorPickerShow;
  rvActionFontColor1.OnHideColorPicker := ColorPickerHide;
  rvActionFontBackColor1.OnShowColorPicker := ColorPickerShow;
  rvActionFontBackColor1.OnHideColorPicker := ColorPickerHide;

  // Initializing the action for showing/hiding thumbnails
  srvActionThumbnails1.PageScroll := SRVPageScroll1;

  // AutoComplete feature causes OnClick generation when editing combo-box's text.
  // Since in OnClick we move input focus in RichViewEdit1, this effect is
  // undesirable
  cmbFont.AutoComplete := False;
  cmbFontSize.AutoComplete := False;

  // measuring units
  RVA_ConvertToTwips(Self);
  RVAControlPanel1.UnitsProgram := rvstuTwips;
  DBSRichViewEdit1.ConvertToTwips;
  cmbUnits.ItemIndex := ord(DBSRichViewEdit1.UnitsProgram);
  RVAControlPanel1.UnitsDisplay := DBSRichViewEdit1.UnitsProgram;

  // Applying the default language
  Localize;

  // Displaying hints on the status bar
  Application.OnHint := ApplicationHint;

  // Opening table
  with FDConnection1.Params do
  begin
    Clear;
    Add('DriverID=IB');
    Add('Database=localhost:' + ExtractFilePath(Application.ExeName) + 'DemoData.ib');
    Add('User_Name=SYSDBA');
    Add('Password=masterkey');
  end;
  FDConnection1.Connected := True;
  FDTable1.Open('');

  //
  DBSRichViewEdit1ZoomChanged(DBSRichViewEdit1);
  DBSRichViewEdit1CaretMove(DBSRichViewEdit1);

  // Smart popups
  DBSRichViewEdit1.SmartPopupProperties.ButtonType := rvsptSimple;

  // Assigning images
  mitImages1Click(nil);
end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
  SearchHelper.Free;
  Application.OnHint := nil;
end;

{--------------- Working with color-picking buttons ---------------------------}

// Code for making color-picking buttons pressed while
// a color-picker window is visible.
procedure TForm3.ColorPickerShow(Sender: TObject);
begin
  if (Sender as TAction).ActionComponent is TToolButton then
    TToolButton(TAction(Sender).ActionComponent).Down := True;
end;

procedure TForm3.ColorPickerHide(Sender: TObject);
begin
  if (Sender as TAction).ActionComponent is TToolButton then
    TToolButton(TAction(Sender).ActionComponent).Down := False;
end;

{-------------- Set of events for processing hypertext links ------------------}

// Hyperlink click
procedure TForm3.RichViewEdit1_Jump(Sender: TObject; id: Integer);
begin
  rvActionInsertHyperlink1.GoToLink(DBSRichViewEdit1.ActiveEditor, id);
end;

// Importing hyperlink
procedure TForm3.RichViewEdit1_ReadHyperlink(Sender: TCustomRichView;
  const Target, Extras: TRVUnicodeString; DocFormat: TRVLoadFormat; var StyleNo: Integer;
  var ItemTag: TRVTag; var ItemName: TRVUnicodeString);
begin
  if DocFormat = rvlfURL then
    StyleNo := rvActionInsertHyperlink1.GetHyperlinkStyleNo
      (Sender as TCustomRichViewEdit);
  ItemTag := rvActionInsertHyperlink1.EncodeTarget(Target);
end;

// URL detection on typing
procedure TForm3.DetectURL;
begin
  rvActionInsertHyperlink1.DetectURL(DBSRichViewEdit1.ActiveEditor);
  rvActionInsertHyperlink1.TerminateHyperlink(DBSRichViewEdit1.ActiveEditor);
end;

procedure TForm3.RichViewEdit1_KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    DetectURL;
end;

procedure TForm3.RichViewEdit1_KeyPress(Sender: TObject; var Key: Char);
begin
  if CharInSet(Key, [#9, ' ', ',', ';']) then
    DetectURL;
end;

{----------------------- Insert table popup      -----------------------------}
{ We use a trick: insert-table button has style tbsDropDown and assigned
  DropDownMenu (pmFakeDropDown). This menu is empty, but shows table size
 popup instead of itself }
procedure TForm3.pmFakeDropDownPopup(Sender: TObject);
begin
  rvActionInsertTable1.ShowTableSizeDialog(DBSRichViewEdit1.ActiveEditor,
    ToolButton12);
end;

{---------------------- Zooming combo box -------------------------------------}
// We could implement zooming using only actions, without a combo box

procedure TForm3.DBSRichViewEdit1ZoomChanged(Sender: TObject);
begin
  UpdatingCombos := True;
  try
    case DBSRichViewEdit1.ViewProperty.ZoomMode of
      rvzmPageWidth:
        cmbZoom.ItemIndex := cmbZoom.Items.Count - 2;
      rvzmFullPage:
        cmbZoom.ItemIndex := cmbZoom.Items.Count - 1;
      rvzmCustom:
        cmbZoom.ItemIndex := cmbZoom.Items.IndexOf
          (IntToStr(Round(DBSRichViewEdit1.ViewProperty.ZoomPercent)));
    end;
  finally
    UpdatingCombos := False;
  end;
end;

procedure TForm3.RVAControlPanel1ViewChanged(Sender: TrvCustomAction;
  Edit: TCustomRichViewEdit);
begin
  DBSRichViewEdit1ZoomChanged(Edit);
end;

// Applying zooming
procedure TForm3.cmbZoomChange(Sender: TObject);
// var Percent : Single;
begin
  if UpdatingCombos then
    exit;
  if cmbZoom.ItemIndex = cmbZoom.Items.Count - 1 then
    DBSRichViewEdit1.ViewProperty.ZoomMode := rvzmFullPage
  else if cmbZoom.ItemIndex = cmbZoom.Items.Count - 2 then
    DBSRichViewEdit1.ViewProperty.ZoomMode := rvzmPageWidth
  else if cmbZoom.ItemIndex >= 0 then
  begin
    DBSRichViewEdit1.ViewProperty.ZoomPercent := StrToIntDef(cmbZoom.Text, 0);
    DBSRichViewEdit1.ViewProperty.ZoomMode := rvzmCustom;
  end;
  {
   // This code will not work, because TsrvActionZoomFullPage and
   // TsrvActionZoomPageWidth are disabled in a web mode

   if cmbZoom.ItemIndex = cmbZoom.Items.Count-1 then
   srvActionsResource.srvActionZoomFullPage1.Execute
   else if cmbZoom.ItemIndex = cmbZoom.Items.Count-2 then
   srvActionsResource.srvActionZoomPageWidth1.Execute
   else if cmbZoom.ItemIndex>=0 then begin
   Percent := srvActionsResource.srvActionZoom1.ZoomPercent;
   srvActionsResource.srvActionZoom1.ZoomPercent := StrToIntDef(cmbZoom.Text, 0);
   srvActionsResource.srvActionZoom1.Execute;
   srvActionsResource.srvActionZoom1.ZoomPercent := Percent;
   end;
  }
end;
{----------------------------- Units combo box --------------------------------}
// Applying units

procedure TForm3.cmbUnitsClick(Sender: TObject);
begin
  DBSRichViewEdit1.UnitsProgram := TRVUnits(cmbUnits.ItemIndex);
  RVAControlPanel1.UnitsDisplay := TRVUnits(cmbUnits.ItemIndex);
  SclRVRuler1.UnitsDisplay := TRulerUnits(cmbUnits.ItemIndex);
  SclRVRuler2.UnitsDisplay := TRulerUnits(cmbUnits.ItemIndex);
end;

{------- Synchronizing ScaleRichView after non-editing operations -------------}

procedure TForm3.RVAControlPanel1MarginsChanged(Sender: TrvAction;
  Edit: TCustomRichViewEdit);
begin
  SclRVRuler1.UnitsDisplay := TRulerUnits(DBSRichViewEdit1.UnitsProgram);
  SclRVRuler2.UnitsDisplay := TRulerUnits(DBSRichViewEdit1.UnitsProgram);
  SclRVRuler1.checkMargin;
  SclRVRuler2.checkMargin;
end;

procedure TForm3.RVAControlPanel1BackgroundChange(Sender: TrvAction;
  Edit: TCustomRichViewEdit);
begin
  DBSRichViewEdit1.Repaint;
end;

{---------------------------- Localization ------------------------------------}

procedure TForm3.btnLanguageClick(Sender: TObject);
begin
  if RVA_ChooseLanguage then
    Localize;
end;

procedure TForm3.Localize;
var
  Index: Integer;
begin
  // Fonts
  Font.Charset := RVA_GetCharset;
  stat1.Font.Charset := RVA_GetCharset;
  Screen.HintFont.Charset := RVA_GetCharset;
  Screen.MenuFont.Charset := RVA_GetCharset;
  // Localizing all actions on this form
  RVA_LocalizeForm(Self);
  // Localizing ruler
  RVALocalizeRuler(SclRVRuler1);
  RVALocalizeRuler(SclRVRuler2);
  // Localizing the editor
  SRVA_LocalizeSRichViewEdit(DBSRichViewEdit1);
  TSRVToolButton(DBSRichViewEdit1.MenuHButtons.Items[0]).Hint :=
    RVADeleteAmp(SRVA_GetS(srvam_act_Draft));
  TSRVToolButton(DBSRichViewEdit1.MenuHButtons.Items[1]).Hint :=
    RVADeleteAmp(SRVA_GetS(srvam_act_WebLayout));
  TSRVToolButton(DBSRichViewEdit1.MenuHButtons.Items[2]).Hint :=
    RVADeleteAmp(SRVA_GetS(srvam_act_PrintLayout));
  // Localizing the search tool window
  SRVA_LocalizeToolWindow(srvtwSearch);
  // Localizing menus and tool buttons
  mitFile.Caption := RVA_GetS(rvam_menu_File);
  mitEdit.Caption := RVA_GetS(rvam_menu_Edit);
  mitFont.Caption := RVA_GetS(rvam_menu_Font);
  mitPara.Caption := RVA_GetS(rvam_menu_Para);
  mitFormat.Caption := RVA_GetS(rvam_menu_Format);
  mitInsert.Caption := RVA_GetS(rvam_menu_Insert);
  mitTable.Caption := RVA_GetS(rvam_menu_Table);
  mitExit.Caption := RVA_GetS(rvam_menu_Exit);
  mitTools.Caption := RVA_GetS(rvam_menu_Tools);

  mitFontSize.Caption := RVA_GetS(rvam_menu_FontSize);
  mitFontStyle.Caption := RVA_GetS(rvam_menu_FontStyle);
  mitTextFlow.Caption := RVA_GetS(rvam_menu_TextFlow);

  mitTableSelect.Caption := RVA_GetS(rvam_menu_TableSelect);
  mitTableCellBorders.Caption := RVA_GetS(rvam_menu_TableCellBorders);
  mitTableAlignCellContents.Caption := RVA_GetS(rvam_menu_TableCellAlign);
  mitTableCellRotation.Caption := RVA_GetS(rvam_menu_TableCellRotation);

  btnPageFormat.Caption := SRVA_GetS(srvam_menu_PageSize);
  btnPageFormat.Hint := RVADeleteAmp(btnPageFormat.Caption);

  // Styles
  rvActionStyleInspector1.UpdateInfo;
  cmbStyles.Localize;

  // Localizing measuring units
  Index := cmbUnits.ItemIndex;
  RVA_TranslateUnits(cmbUnits.Items);
  cmbUnits.ItemIndex := Index;

  // Localizing the zoom combo box

  Index := cmbZoom.ItemIndex;
  cmbZoom.Items[cmbZoom.Items.Count - 2] := RVA_GetS(rvam_pp_PageWidth);
  cmbZoom.Items[cmbZoom.Items.Count - 1] := RVA_GetS(rvam_pp_FullPage);
  cmbZoom.ItemIndex := Index;

  // Localizing text on the status bar
  DBSRichViewEdit1CurrentPageChange(DBSRichViewEdit1);
  DBSRichViewEdit1PageScrolled(DBSRichViewEdit1);
  DBSRichViewEdit1CaretMove(DBSRichViewEdit1);

end;

{------------------------------ Status bar ------------------------------------}
// Displaying the index of the edited page (OnCurrentPageChange and OnPageCountChanged)
procedure TForm3.DBSRichViewEdit1CurrentPageChange(Sender: TObject);
begin
  stat1.Panels.Items[1].Text := Format(SRVA_GetS(srvam_PageMofN),
    [DBSRichViewEdit1.CurrentPage, DBSRichViewEdit1.PageCount]);
end;

// Displaying the index of the visible page
procedure TForm3.DBSRichViewEdit1PageScrolled(Sender: TObject);
begin
  stat1.Panels.Items[0].Text := Format(SRVA_GetS(srvam_ViewPageX),
    [DBSRichViewEdit1.ScrolledPage]);
end;

// Displaying the current line and column

procedure TForm3.DBSRichViewEdit1CaretMove(Sender: TObject);
var
  Line, Column: Integer;
begin
  if (DBSRichViewEdit1 <> nil) then
  begin
    DBSRichViewEdit1.GetCurrentLineCol(Line, Column);
    stat1.Panels.Items[2].Text := Format(SRVA_GetS(srvam_LineX), [Line]);
    stat1.Panels.Items[3].Text := Format(SRVA_GetS(srvam_ColX), [Column]);
    UpdateSmartPopup;
  end;
end;

// switching to header/footer/main
procedure TForm3.DBSRichViewEdit1ChangeActiveEditor(Sender: TSRichViewEdit;
  ActiveEditor: TRichViewEdit);
begin
  DBSRichViewEdit1CaretMove(DBSRichViewEdit1);
end;

// Displaying hints
procedure TForm3.ApplicationHint(Sender: TObject);
var
  s: String;
begin
  s := GetLongHint(Application.Hint);
  stat1.SimplePanel := s <> '';
  stat1.SimpleText := s;
  stat1.Repaint;
end;

{--------------------- Buttons on scroll-bars ---------------------------------}
// On horizontal scroll bar (view modes)
procedure TForm3.DBSRichViewEdit1HMenuClickButton(Sender: TObject;
  ToolButton: TSRVToolButton);
begin
  if ToolButton = nil then
    exit;
  DBSRichViewEdit1.CanUpdate := False;
  case (ToolButton.Index) of
    0:
      srvActionLayoutDraft1.Execute;
    1:
      srvActionLayoutWeb1.Execute;
    2:
      srvActionLayoutPrint1.Execute;
  end;
  DBSRichViewEdit1.CanUpdate := True;
end;

{-------------------- Progress messages ---------------------------------------}
// Downloading images referred in RTF or HTML (when Indy or CleverComponents are used)
procedure TForm3.RVAControlPanel1Download(Sender: TrvAction;
  const Source: TRVUnicodeString);
begin
  if Source = '' then
    Application.Hint := ''
  else
    Application.Hint := RVAFormat(RVA_GetS(rvam_msg_Downloading), [Source]);
end;

// Printing
procedure TForm3.DBSRichViewEdit1Printing(Sender: TSRichViewEdit;
  PageCompleted: Integer; Step: TRVPrintingStep);
begin
  Application.Hint := RVA_GetPrintingMessage(PageCompleted, Step);
end;

// Reading/writing
procedure TForm3.DBSRichViewEdit1Progress(Sender: TCustomRichView;
  Operation: TRVLongOperation; Stage: TRVProgressStage; PercentDone: Byte);
begin
  case Stage of
    rvpstgStarting:
      begin
        ProgressBar1.Left := btnLanguage.Left - ProgressBar1.Width - 10;
        ProgressBar1.Top := btnLanguage.Top +
          (btnLanguage.Height - ProgressBar1.Height) div 2;
        ProgressBar1.Position := 0;
        ProgressBar1.Visible := True;
        Application.Hint := RVA_GetProgressMessage(Operation);
      end;
    rvpstgRunning:
      begin
        ProgressBar1.Position := PercentDone;
        ProgressBar1.Update;
      end;
    rvpstgEnding:
      begin
        ProgressBar1.Position := 100;
        ProgressBar1.Update;
        Application.Hint := '';
        ProgressBar1.Visible := False;
      end;
  end;
end;

{-------------------------------- Misc. ---------------------------------------}
// On clicking a table icon
procedure TForm3.DBSRichViewEdit1TableIconClick(Sender: TSRichViewEdit;
  Button: TMouseButton; Shift: TShiftState; X, Y, PageNo: Integer);
begin
  Sender.GetTableIconItem.SelectRows(0, Sender.GetTableIconItem.RowCount);
  Sender.Repaint;
end;

// Double clicking on the rulers' margins shows the page setup dialog
procedure TForm3.SclRVRuler1MarginDblClick(Sender: TObject;
  Margin: TMarginType);
begin
  srvActionPageSetup1.ExecuteTarget(DBSRichViewEdit1);
end;

// After TsrvActionThumbnails is executed
procedure TForm3.srvActionThumbnails1Executed(Sender: TObject);
begin
  Splitter1.Visible := TsrvActionThumbnails(Sender).Checked;
  SRVPageScroll1.Visible := TsrvActionThumbnails(Sender).Checked;
end;


// exiting
procedure TForm3.mitExitClick(Sender: TObject);
begin
  Close;
end;

{------------------------------ Smart Popups ----------------------------------}
// This procedure is called in OnCaretMove.
// A button is displayed for pictures, horizontal lines, notes
procedure TForm3.UpdateSmartPopup;
begin
  if DBSRichViewEdit1.ActiveEditor.ItemCount = 0 then
    exit;
  case DBSRichViewEdit1.ActiveEditor.CurItemStyle of
    rvsPicture, rvsHotPicture, rvsBreak:
      SmartPopupAction := rvActionItemProperties1;
    rvsFootnote, rvsEndnote:
      SmartPopupAction := srvActionEditNote1;
    rvsNoteReference:
      SmartPopupAction := srvActionReturnToNote1;
    else
      SmartPopupAction := nil;
  end;
  if SmartPopupAction <> nil then
  begin
    DBSRichViewEdit1.SmartPopupProperties.Hint := SmartPopupAction.Hint;
    DBSRichViewEdit1.SmartPopupProperties.ImageIndex := SmartPopupAction.ImageIndex;
  end;
  DBSRichViewEdit1.SmartPopupVisible := SmartPopupAction <> nil;
end;

procedure TForm3.DBSRichViewEdit1SmartPopupClick(Sender: TCustomRichView;
  Button: TCustomControl);
begin
  if SmartPopupAction <> nil then
    SmartPopupAction.Execute;
end;

procedure TForm3.ChangeImages(ilNormal, ilDisabled, ilMenuH, ilMenuV,
  ilSearchToolWin: TCustomImageList; IconStyle: TSRVIconStyle;
  SearchToolWinColor, SearchToolWinFontColor, SearchToolSelColor,
  SearchToolDownColor: TColor);
var
  i: Integer;
begin
  for i := 0 to ComponentCount - 1 do
    if Components[i] is TToolBar then
    begin
      TToolBar(Components[i]).Images := ilNormal;
      TToolBar(Components[i]).DisabledImages := ilDisabled;
    end;
  MainMenu1.Images := ilNormal;
  RVAPopupMenu1.Images := ilNormal;
  pmZoom.Images := ilNormal;
  pmPageFormat.Images := ilNormal;
  rvActionStyleTemplates1.Images := ilNormal;
  rvActionStyleInspector1.Images := ilNormal;
  rvActionStyleInspector1.UpdateInfo;
  cmbStyles.Images := ilNormal;
  DBSRichViewEdit1.MenuHorizontal.ImageList := ilMenuH;
  DBSRichViewEdit1.MenuHorizontal.Color := SearchToolWinColor;
  DBSRichViewEdit1.MenuHorizontal.ColorSelect := SearchToolSelColor;
  DBSRichViewEdit1.MenuHorizontal.ColorDown := SearchToolDownColor;
  DBSRichViewEdit1.MenuVertical.ImageList := ilMenuV;
  DBSRichViewEdit1.MenuVertical.Color := SearchToolWinColor;
  DBSRichViewEdit1.MenuVertical.ColorSelect := SearchToolSelColor;
  DBSRichViewEdit1.MenuVertical.ColorDown := SearchToolDownColor;
  DBSRichViewEdit1.ViewProperty.IconStyle := IconStyle;
  DBSRichViewEdit1.SmartPopupProperties.ImageList := ilNormal;
  srvtwSearch.ImageList := ilSearchToolWin;
  srvtwSearch.Color := SearchToolWinColor;
  srvtwSearch.ColorSelect := SearchToolSelColor;
  srvtwSearch.ColorDown := SearchToolDownColor;
  srvtwSearch.HintFont.Color := SearchToolWinFontColor;
end;

procedure TForm3.mitImages1Click(Sender: TObject);
begin
  with dmSRVImages1 do
    ChangeImages(ilNormal, ilDisabled, ilMenuH, ilMenuV, ilSearchToolWin,
      srvisNormal, SearchToolWinColor, SearchToolWinFontColor,
      SearchToolSelColor, SearchToolDownColor);
end;

procedure TForm3.mitImages2Click(Sender: TObject);
begin
  with dmSRVImages2 do
    ChangeImages(ilNormal, ilDisabled, ilMenuH, ilMenuV, ilSearchToolWin,
      srvisFlat, SearchToolWinColor, SearchToolWinFontColor, SearchToolSelColor,
      SearchToolDownColor);
end;

procedure TForm3.mitOptionsClick(Sender: TObject);
var
  frm: TfrmOptions;
begin
  // This form is not a part of RichViewActions, so it is not localized
  frm := TfrmOptions.Create(Application);
  try
    frm.cmbTextEngine.ItemIndex := ord(DBSRichViewEdit1.TextEngine);
    frm.cbMetafilePrint.Checked := RVAControlPanel1.MetafileCompatibility;
    if frm.ShowModal = mrOk then
    begin
      RVAControlPanel1.MetafileCompatibility := frm.cbMetafilePrint.Checked;
      if frm.cmbTextEngine.ItemIndex <> ord(DBSRichViewEdit1.TextEngine) then
      begin
        DBSRichViewEdit1.TextEngine := TRVTextEngine(frm.cmbTextEngine.ItemIndex);
        DBSRichViewEdit1.Reformat;
      end;
    end;
  finally
    frm.Free;
  end;
end;

{=========================== DB functions =====================================}
procedure TForm3.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if (FDTable1.RecordCount=0) and (FDTable1.State <> dsInsert) then
    stat1.Panels[5].Text := 'No records'
  else if FDTable1.RecNo<1 then
    stat1.Panels[5].Text := 'New record'
  else
    stat1.Panels[5].Text :=
      Format('Record %d of %d', [FDTable1.RecNo, FDTable1.RecordCount]);
end;

procedure TForm3.DBSRichViewEdit1NewDocument(Sender: TObject);
begin
  // This demo does not use rvActionNew1 by itself, as well saving and opening
  // actions.
  // (to avoid an accidental use, we cleared its rvActionNew1.Shortcut).
  // However, we need it to assign default document properties:
  rvActionNew1.Reset(DBSRichViewEdit1.RichViewEdit)
end;


procedure TForm3.FDTable1AfterScroll(DataSet: TDataSet);
begin
  SclRVRuler1.checkMargin;
  SclRVRuler2.checkMargin;
  DBSRichViewEdit1.ActiveEditor.CurTextStyleChange;
  DBSRichViewEdit1.ActiveEditor.CurParaStyleChange
end;

end.
